Updated and simplified PHP testing structure (#8558)

* Simplified PHP testing setup.

- Consolidated on a single autoloader, created by composer.
- Consolidated on a single phpunit invocation strategy: we run
  phpunit on a directory, which will run all tests matching *Test.php
  in that directory.
- We now rely on autoloading to import all test protos. require_once()
  calls for test protos are removed.
- For now the valgrind tests are removed. A follow-up PR will re-enable
  them in a more robust way.

* More improvements to PHP testing.

1. Replace custom PHPUnit-selection logic in test.sh with generic
   composer version selection.
2. Optimized both test proto generation and the custom extension
   build to avoid unnecessary work when the files are already up
   to date.

* Added assertions to verify that the C test doesn't use PHP sources.

* Updated tests.sh for the new PHP testing commands.

* Removed obsolete rules from tests.sh.

* Fixed generate_test_protos.sh for when tmp does not exist.

Also removed undefined_test.php and fixed Makefile.am.

* Added php8.0_all again which is still used.

* Added missing file to Makefile.am.

* Re-added php_all_32 rule which is also still used.

* Updated testing commands for macOS and download composer.

* Use /usr/local/bin on mac instead of /usr/bin, since the latter is not writable.
diff --git a/php/generate_test_protos.sh b/php/generate_test_protos.sh
new file mode 100755
index 0000000..0aa4bdb
--- /dev/null
+++ b/php/generate_test_protos.sh
@@ -0,0 +1,27 @@
+#!/bin/bash
+
+set -e
+
+cd `dirname $0`
+
+if [[ -d tmp && -z $(find tests/proto ../src/protoc -newer tmp) ]]; then
+  # Generated protos are already present and up to date, so we can skip protoc.
+  #
+  # Protoc is very fast, but sometimes it is not available (like if we haven't
+  # built it in Docker). Skipping it helps us proceed in this case.
+  echo "Test protos are up-to-date, skipping protoc."
+  exit 0
+fi
+
+rm -rf tmp
+mkdir -p tmp
+
+find tests/proto -type f -name "*.proto"| xargs ../src/protoc --php_out=tmp -I../src -Itests
+
+if [ "$1" = "--aggregate_metadata" ]; then
+  # Overwrite some of the files to use aggregation.
+  AGGREGATED_FILES="tests/proto/test.proto tests/proto/test_include.proto tests/proto/test_import_descriptor_proto.proto"
+  ../src/protoc --php_out=aggregate_metadata=foo#bar:tmp -I../src -Itests $AGGREGATED_FILES
+fi
+
+echo "Generated test protos from tests/proto -> tmp"